import os

import pygame
from Mind import Orientation, Existence

from doc.src import logic


def copy_log(log):
    r_log = Existence.Logic([[], [], [], []])
    r_log.lf = log.lf
    r_log.lc = log.lc
    return r_log


class core:
    def __init__(self, main):
        self.main = main

        os.chdir("doc/art/tutorial")

        self.images = [[pygame.image.load("../pl/" + str(x + 1) + "/" +
          str(y + 1) + '.png') for y in range(2)] for x in range(3)]

        self.fight = False

        self.sold1 = Existence.mov_type(None, self.images[0],
          props={"lives": 50, "core": self}, logic=copy_log(logic.basic) +
          Existence.Subject, name="1")
        self.sold2 = Existence.mov_type(None, self.images[1],
          props={"lives": 70, "core": self}, logic=copy_log(logic.deton) +
          Existence.Subject, name="2")
        self.sold3 = Existence.mov_type(None, self.images[2],
          props={"lives": 30, "core": self}, logic=copy_log(logic.flyer) +
          Existence.Subject, name="3")
        self.tar = Existence.mov_type(None,
          pygame.image.load("../pl/t/1.png"), props={"lives": 20, "core":
          self}, logic=logic.basic)
        self.list = {"t": self.tar, "1": self.sold1, "2": self.sold2, "3":
          self.sold3}

        self.laser = Existence.mov_type(None,
          pygame.image.load("../ls.bmp"), width=10, height=3, props={"hit":
          pygame.mixer.Sound("../snd/hit.wav")}, logic=logic.laser)
        self.laser.cls.width = 10
        self.laser.cls.height = 3

        self.mine = Existence.mov_type(None,
          [pygame.image.load("../e" + str(x + 1) + ".png") for x in
          range(5)], width=4, height=10, props={"exp":
          pygame.mixer.Sound("../snd/explosion.wav")}, logic=logic.Mine)
        self.mine.cls.width = 4
        self.mine.cls.height = 10

        self.bomb = Existence.mov_type(None,
          [pygame.image.load("../bm" + str(x + 1) + ".png") for x in
          range(5)], width=4, height=10,
          props={"exp": pygame.mixer.Sound("../snd/explosion.wav")},
          logic=logic.bomb)
        self.bomb.cls.width = 5
        self.bomb.cls.height = 5

        self.laser_gr = Orientation.objectgroup("laser", {}, [], None)

    def load_map(self, n):
        self.Map = Orientation.tiled_map(str(n), [{}, {}, self.list])

        self.laser.Map = self.mine.Map = self.bomb.Map =\
          self.laser_gr.Map = self.Map
        self.laser_gr.objects = []
        self.Map.objectgroups.append(self.laser_gr)
        self.lasers = self.laser_gr.objects
        self.ls = self.lasers[:]

        for gr in self.Map.objectgroups:
            if gr.name == "spawns":
                self.chars = gr.objects
        self.ch2 = self.chars[:]

        self.main.Map = self.Map
        self.main.exp = self.Map.clone_obj(str(n), "type")

    def start(self, *args):
        self.n = 1
        self.load_map(1)

    def next(self):
        self.n += 1
        self.load_map(self.n)

    def battle(self):
        self.Map = Orientation.tiled_map("../real/1", [{}, {}, self.list])
        self.time = pygame.time.get_ticks()
        self.fight = True
        self.laser.Map = self.mine.Map = self.bomb.Map =\
          self.laser_gr.Map = self.Map
        self.laser_gr.objects = []
        self.Map.objectgroups.append(self.laser_gr)
        self.lasers = self.laser_gr.objects
        self.ls = self.lasers[:]

        for gr in self.Map.objectgroups:
            if gr.name == "spawns":
                self.chars = gr.objects
        self.ch2 = self.chars[:]

        self.main.Map = self.Map

    def update(self):
        for p, char in enumerate(self.ch2):
            if char.lives <= 0:
                del self.chars[p]
                for p2, char2 in enumerate(self.ch2):
                    if p != p2:
                        del char2.chars[p - (p2 < p)]
                        char2.coll = char2.wll + char2.chars
        if self.ch2 != self.chars:
            self.ch2 = self.chars[:]
        for p, las in enumerate(self.ls):
            if not las.live:
                del self.lasers[p]
        if self.ls != self.lasers:
            self.ls = self.lasers[:]
        if self.fight and pygame.time.get_ticks() - self.time > 120000:
            with open("score.txt", "w") as sc:
                one = 0
                two = 0
                for ch in self.chars:
                    if ch.opts[0] == 1:
                        one += ch.lives
                    else:
                        two += ch.lives
                sc.write(str(one) + ", " + str(two))
            self.main.Game.kill()
