import os

import pygame
from Mind import Imagination

from . import lang


class script:

    def __init__(self, Game):
        self.Game = Game

        self.keyboard = self.Game.keyboard
        self.keyboard.extend([(pygame.K_1, "."), (pygame.K_q, "\\"),
          (pygame.K_2, "$"), (pygame.K_w, "~"), (pygame.K_3, "("),
          (pygame.K_4, ")"), (pygame.K_e, "["), (pygame.K_r, "]"),
          (pygame.K_5, "{"), (pygame.K_6, "}"), (pygame.K_t, "<"),
          (pygame.K_y, ">"), (pygame.K_BACKSPACE, "back"), ])

        self.font = self.Game.font

        self.screen = pygame.display.get_surface()
        self.size = self.width, self.height = self.screen.get_size()

        self.core = self.Game.core
        self.exp = self.Game.exp

        self.printer = Imagination.printer(self.width * 0.1, self.height *
          0.7, self.font, 70, (0, 0, 0))
        Imagination.set_printer(self.printer)

    def blit(self):
        pygame.draw.rect(self.screen, (192, 192, 192),
          pygame.Rect(self.width * 0.1, self.height * 0.7, self.width *
          0.8, 70))
        d = self.keyboard.keys
        for x in filter(lambda x: d[x] == 1, d):
            if len(x) == 1:
                print(x, end="")
        if self.keyboard["hit"] == 1:
            if self.printer.text:
                self.exp.cmd(lang.sym_num(self.printer.text))
                self.printer.clear()
        if self.keyboard["back"] == 1:
            if self.printer.text:
                self.printer.text = self.printer.text[:-1]
        self.printer.blit()


class editor:

    def __init__(self, Game):
        self.Game = Game

        self.keyboard = self.Game.keyboard
        self.keyboard.extend([(pygame.K_1, "."), (pygame.K_q, "\\"),
          (pygame.K_2, "$"), (pygame.K_w, "~"), (pygame.K_3, "("),
          (pygame.K_4, ")"), (pygame.K_e, "["), (pygame.K_r, "]"),
          (pygame.K_5, "{"), (pygame.K_6, "}"), (pygame.K_t, "<"),
          (pygame.K_y, ">"), (pygame.K_BACKSPACE, "back"), (pygame.K_a,
          "!"), (pygame.K_s, "?"), (pygame.K_d, ":"), (pygame.K_f, "_"),
          (pygame.K_c, "|"), (pygame.K_g, "/"), (pygame.K_v, "@"),
          (pygame.K_b, "-"), (pygame.K_h, "+"), (pygame.K_n, "*"),
          (pygame.K_j, ";"), (pygame.K_m, "^"), (pygame.K_RSHIFT, "save")])

        self.font = self.Game.font

        self.screen = pygame.display.get_surface()
        self.size = self.width, self.height = self.screen.get_size()

        self.core = self.Game.core

        self.printer = Imagination.printer(10, 10, self.font, 70,
          (255, 255, 255))
        Imagination.set_printer(self.printer)

        self.save = len(os.listdir("../sav")) + 1
        self.load = 1

    def blit(self):
        self.screen.fill((0, 0, 0))
        d = self.keyboard.keys
        for x in filter(lambda x: d[x] == 1, d):
            if len(x) == 1:
                print(x, end="")
        if self.keyboard["hit"] == 1:
            if self.printer.text:
                self.Game.exp.run = lang.run(self.printer.text,
                  self.Game.exp)
                self.Game.Game.change(self.Game.places[1])
        if self.keyboard["back"] == 1:
            if self.printer.text:
                self.printer.text = self.printer.text[:-1]
        if self.keyboard["save"] == 1:
            if self.printer.text:
                with open("../sav/" + str(self.save) + ".txt", "w") as F:
                    F.write(self.printer.text)
                    self.save += 1
        if self.keyboard["fire"] == 1:
            try:
                with open("../sav/" + str(self.load) + ".txt") as F:
                    self.printer.text = F.read()
                    self.load += 1
                    if self.load == self.save:
                        self.load = 1
            except Exception:
                pass
        self.printer.blit()
        if self.printer.text and self.printer.ren.get_width() > self.width\
          - 10:
            c = self.printer.text[-1]
            self.printer.text = self.printer.text[:-1]
            print("\n" + c, end="")