import re


def sym_num(s):
    num = 0
    val = {'.': 1, '\\': 5, '$': 20, '~': 100}
    pos = ".\\$~"
    for p, x in enumerate(s):
        if x == '~' or p + 1 == len(s) or pos[pos.index(x) + 1] != s[p + 1]:
            num += val[x]
        else:
            num -= val[x]
    return num


def s_num(s, vs, q, obj):
    n = ".\\$~"
    v = "+*^;"
    if s[0] in n:
        return sym_num(s)
    if s[0] in v:
        return vs[s]
    else:
        return ask(s[2:-2:], obj, q, vs)
        

def e_num(s, vs, q, obj):
    var = [""]
    op = []
    ni, qs = search(s, "<?", "?>", False, False)
    for p, x in enumerate(s):
        if x in "_/@-":
            for st in qs:
                if st < p < qs[st]:
                    var[-1] = var[-1] + x
                    break
            else:
                var.append("")
                op.append(x)
        else:
            var[-1] = var[-1] + x
    val = s_num(var[0], vs, q, obj)
    for p, v in enumerate(var[1:]):
        if op[p] == "_":
            val += s_num(v, vs, q, obj)
        if op[p] == "/":
            val -= s_num(v, vs, q, obj)
        if op[p] == "@":
            val *= s_num(v, vs, q, obj)
        if op[p] == "-":
            val //= s_num(v, vs, q, obj)
    return val


def div_parts(s):
    n1 = s.find("!~")
    n2 = s.find("?~")
    return [s[1:n1], s[n1 + 3:n2], s[n2 + 2:]]


def cmd_qst(cmd, qst):
    cd = {}
    qd = {}
    cmd = cmd.split(">")[:-1]
    qst = qst.split(">")[:-1]
    for x in cmd:
        p = x.split("<")
        cd[p[0]] = sym_num(p[1])
    for x in qst:
        p = x.split("<")
        qd[p[0]] = sym_num(p[1])
    return cd, qd


def exe(s, obj, cd, qs, vs):
    if "[" in s:
        obj.cmd(cd[s[:s.find("[")]], p=e_num(s[s.find("[") + 1:-1], vs, qs, obj))
    else:
        obj.cmd(cd[s])


def ask(s, obj, qs, vs):
    if "[" in s:
        obj.cmd(qs[s[:s.find("[")]], "q", e_num(s[s.find("[") + 1:-1], vs, qs, obj))
    else:
        obj.cmd(qs[s], "q")
    return obj.ret


def search(s, st, en, end0=True, short=True):
    op = 0
    pri = {}
    end = {}
    for p, x in enumerate(s):
        if s[p:p+len(st)] == st:
            op += 1
            if op in pri:
                pri[op].append(p + (len(st) if short else 0))
            else:
                pri[op] = [p + (len(st) if short else 0)]
        if s[p:p+len(en)] == en:
            end[pri[op][-1]] = p + (0 if short else len(en))
            op -= 1
        if end0 and op == 0:
            return pri, end
    return pri, end


def bol(s, v, q, o):
    if "||" in s:
        return e_num(s.split("||")[0], v, q, o) == e_num(s.split("||")[1], v, q, o)
    if "|::" in s:
        return e_num(s.split("|::")[0], v, q, o) >= e_num(s.split("|::")[1], v, q, o)
    elif "|:" in s:
        return e_num(s.split("|:")[0], v, q, o) > e_num(s.split("|:")[1], v, q, o)
    if "::|" in s:
        return e_num(s.split("::|")[0], v, q, o) <= e_num(s.split("::|")[1], v, q, o)
    elif ":|" in s:
        return e_num(s.split(":|")[0], v, q, o) < e_num(s.split(":|")[1], v, q, o)


class run:
    def __init__(self, s, obj):
        self.cmd, self.qst, self.cod = div_parts(s.replace("\n", ""))
        self.cd, self.qd = cmd_qst(self.cmd, self.qst)
        self.var = {}
        self.ind = 0
        self.obj = obj
        ni, self.qs = search(self.cod, "<?", "?>", False, False)

    def run(self):
        self.ind %= len(self.cod)
        if self.cod[self.ind] == "!":
            exe(self.cod[self.ind + 1:self.cod.find("!", self.ind + 1)], self.obj, self.cd, self.qd, self.var)
            self.ind = self.cod.find("!", self.ind + 1) + 1
        elif self.cod[self.ind] == "(":
            pri, end = search(self.cod[self.ind:], "(", ")")
            s = self.cod[self.ind + 1:self.ind + end[1]]
            vals = [bol(x, self.var, self.qd, self.obj) for x in re.split("(?<!\|)[|&](?!\|)", s)]
            var = vals[0]
            i = 0
            for x in vals[1:]:
                i = min(s.find("|", i), s.find("&", i))
                if s[i] == "|":
                    var |= x
                else:
                    var &= x
                i += 1
            self.ind += end[1] + 1
            if var:
                self.ind += 1
            else:
                pri, end = search(self.cod[self.ind:], "<", ">")
                self.ind += end[1] + 1
                self.ind += (self.cod[self.ind] == ":") + (self.cod[self.ind + 1] == "<" and self.cod[self.ind] == ":")
            self.run()
        elif self.cod[self.ind] == ">":
            if self.cod[(self.ind + 1) % len(self.cod)] == ":":
                self.ind += 2
                s = self.cod[self.ind:]
                pri, end = search(s, "<", ">", False)
                for st in pri[1]:
                    for st2 in self.qs:
                        if st2 < st < self.qs[st2]:
                            break
                    else:
                        if s[end[st] + 1] != ":":
                            self.ind += end[st] + 1
                            break
            else:
                self.ind += 1
            self.run()
        elif self.cod[self.ind] in "+*;^":
            s = re.findall("[^(!]+", self.cod[self.ind:])[0]
            self.var[s.split("|")[0]] = e_num(s.split("|")[1], self.var, self.qd, self.obj)
            self.ind += len(s)
            self.run()
        self.ind %= len(self.cod)
