import pygame
from Mind import Orientation, Existence


@Existence.logic_class
class laser:
    def __init__(self):
        self.coll = self.Map.clone_obj("walls", "group")
        self.chars = self.Map.clone_obj("spawns", "group")
        if type(self.chars) != list:
            self.chars = [self.chars]
        self.obj = Orientation.rect(self.x, self.y, self.width,
          self.height, self.Map.in_map)
        self.live = True

    def blit(self):
        if self.live:
            self.move(-5 if self.props["dir"] == 1 else 5, 0)

    def move(self):
        self.obj.x = self.x
        self.obj.y = self.y

        for obj in self.coll:
            if any(self.obj.collide(obj.obj)):
                self.live = False

        for obj in self.chars:
            if any(self.obj.collide(obj.obj)):
                if obj.lives:
                    self.live = False
                    obj.lives -= 5
                    self.props["hit"].play()


def listed(l_or_o):
    if type(l_or_o) == list:
        return l_or_o
    return [l_or_o]


@Existence.logic_class
class Mine:
    def __init__(self):
        self.coll = self.Map.clone_obj("walls", "group")
        self.chars = self.Map.clone_obj("spawns", "group")
        if type(self.chars) != list:
            self.chars = [self.chars]
        self.obj = Orientation.rect(self.x, self.y, self.width,
          self.height, self.Map.in_map)
        self.live = True
        self.pictures = self.picture
        self.picture = self.pictures[0]
        self.d = 0
        self.cl = 0

        self.centre = Orientation.point(self.x + self.width / 2, self.y +
          self.height / 2, self.Map.in_map)

    def detonate(self):
        self.props["exp"].play()
        self.picture = self.pictures[1]
        self.d = 1
        self.picture = self.pictures[self.d]
        self.x -= (self.picture.get_width() - self.width) / 2
        self.y -= (self.picture.get_height() - self.width) / 2
        self.width, self.height = self.picture.get_size()

    def blit(self):
        if self.d:
            if self.cl == 5:
                self.d += 1
                self.cl = 0
                if self.d < 5:
                    self.picture = self.pictures[self.d]
                    self.x -= (self.picture.get_width() - self.width) / 2
                    self.y -= self.picture.get_height() - self.height
                    self.width, self.height = self.picture.get_size()
                else:
                    self.live = False
                for ch in listed(self.chars):
                    ch.lives -= max(0, 8 - self.centre.distance(ch.centre)
                      / 10)
            else:
                self.cl += 1


@Existence.logic_class
class bomb:
    def __init__(self):
        self.coll = self.Map.clone_obj("walls", "group")
        self.chars = self.Map.clone_obj("spawns", "group")
        if type(self.chars) != list:
            self.chars = [self.chars]
        self.obj = Orientation.rect(self.x, self.y, self.width,
          self.height, self.Map.in_map)
        self.live = True
        self.pictures = self.picture
        self.picture = self.pictures[0]
        self.d = 0
        self.cl = 0

        self.centre = Orientation.point(self.x + self.width / 2, self.y +
          self.height / 2, self.Map.in_map)

        self.fx, self.fy = self.props["move"]

    def blit(self):
        if self.d:
            if self.cl == 5:
                self.d += 1
                self.cl = 0
                if self.d < 5:
                    self.picture = self.pictures[self.d]
                    self.x -= (self.picture.get_width() - self.width) / 2
                    self.y -= self.picture.get_height() - self.height
                    self.width, self.height = self.picture.get_size()
                else:
                    self.live = False
                for ch in listed(self.chars):
                    ch.lives -= max(0, 5 - self.centre.distance(ch.centre)
                      / 10)
            else:
                self.cl += 1
        else:
            self.move(self.fx, self.fy)
            self.fy += 0.1
            self.obj.x = self.x
            self.obj.y = self.y
            for obj in self.coll:
                if any(self.obj.collide(obj.obj)):
                    self.d = 1
                    self.props["exp"].play()
                    self.centre.x = self.x + self.width / 2
                    self.centre.y = self.y + self.height / 2

            for obj in self.chars:
                if any(self.obj.collide(obj.obj)):
                    if obj.lives:
                        self.d = 1
                        obj.lives -= 10
                        self.props["exp"].play()
                    self.centre.x = self.x + self.width / 2
                    self.centre.y = self.y + self.height / 2


def go(self, d):
    if d == 1:
        self.move(-3, 0)
    else:
        self.move(3, 0)
    self.dir = d


def jump(self):
    if self.ground:
        self.fy -= 3
        self.ground = False


def fire(self):
    if pygame.time.get_ticks() - self.time > 1000:
        self.fire.play()
        self.laser_gr.objects.append(self.laser(self.x + (self.width if
          self.dir == 2 else -10), self.y + 11, "laser",
          props={"dir": self.dir}))
        self.time = pygame.time.get_ticks()


def mine(self):
    if not self.Mine:
        self.Mine = self.mine(self.x + 5, self.y + 4, "mine")
        self.laser_gr.objects.append(self.Mine)


def detonate(self):
    if self.Mine:
        self.Mine.detonate()
        self.Mine = None


def move(self):
    self.dr.move(2)
    self.move(0, 0)


def turn(self, d):
    self.dr.ch_angle(-1 if d == 1 else 1)
    self.ln.points = (self.dr.point, self.dr.get_pos(100))


def fire_b(self, s=5):
    if pygame.time.get_ticks() - self.time > 1000:
        p = self.dr.get_pos(s)
        fx = p.x - self.centre.x
        fy = p.y - self.centre.y
        x, y = self.dr.get_pos(20).get_xy()
        self.laser_gr.objects.append(self.bomb(x, y, "bomb",
          props={"move": (fx, fy)}))
        self.time = pygame.time.get_ticks()


def scan(self, t=1):
    for obj in self.coll:
        if any(self.scan_rect.collide(obj.obj)):
            if t == 1:
                return 2
            if t == 2:
                return 2 + (obj in self.chars) + (obj in self.chars and
                  self.fight and obj.opts[0] == self.opts[0])
            if t == 3:
                return 1 + (obj in self.chars) + 4 if obj.type == "t" else\
                  int(obj.type)
    return 1


def scan_l(self, t=1):
    for obj in self.coll:
        if obj.obj in self.ln:
            if t == 1:
                return 2
            if t == 2:
                return 2 + (obj in self.chars) + (obj in self.chars and
                  self.fight and obj.opts[0] == self.opts[0])
            if t == 3:
                return 1 + (obj in self.chars) + 4 if obj.type == "t" else\
                  int(obj.type)
    return 1


@Existence.logic_class
class basic:
    def __init__(self):
        self.fy = 0
        self.first = True
        self.size = self.width, self.height = self.picture[0].get_size()\
          if self.type == "1" else self.picture.get_size()
        self.obj = Orientation.rect(self.x, self.y, self.width,
          self.height, self.Map.in_map)
        self.scan_rect = Orientation.rect(self.x - 200, self.y, 200,
          self.height, self.Map.in_map)
        self.run = None
        self.ground = False

        self.time = pygame.time.get_ticks()

        self.lives = self.props["lives"]

        self.centre = Orientation.point(self.x + self.width / 2, self.y +
          self.height / 2, self.Map.in_map)

        if self.type == "1":
            self.dir = 1
            self.pictures = self.picture
            self.picture = self.pictures[self.dir]

            self.fire = pygame.mixer.Sound("../snd/laser.wav")

    def blit(self):
        pygame.draw.rect(self.Map.screen, (40, 255, 40),
          pygame.Rect(self.get_blit()[0] + self.width / 2 - self.lives / 4,
          self.get_blit()[1] - 5, self.lives / 2, 3))
        pygame.draw.rect(self.Map.screen, (255, 0, 0),
          pygame.Rect(self.scan_rect.x, self.scan_rect.y,
          self.scan_rect.width, self.scan_rect.height), 1)
        if self.first:
            self.wll = self.Map.clone_obj("walls", "group")
            self.chars = self.Map.clone_obj("spawns", "group")
            for p, ch in enumerate(self.chars):
                if ch == self:
                    del self.chars[p]
                    break
            self.coll = self.wll + self.chars

            self.commands = [go, jump, fire]
            self.scans = [lambda self: self.ground + 1, scan]

            self.core = self.props["core"]
            self.laser_gr = self.core.laser_gr
            self.laser = self.core.laser
            self.fight = self.core.fight

            self.first = False

        if self.run:
            self.run.run()

        if self.type == "1":
            self.fy += 0.1
            self.move(0, self.fy)

            self.picture = self.pictures[self.dir - 1]

    def move(self):
        self.obj.x = self.x
        self.obj.y = self.y

        self.scan_rect.x = self.x + (self.width if self.dir == 2 else -200)
        self.scan_rect.y = self.y

        self.centre.x = self.x + self.width / 2
        self.centre.y = self.y + self.height / 2

        for obj in self.coll:
            cl = self.obj.collide(obj.obj)
            Mn = min(filter(lambda x: x, cl)) if list(filter(lambda x: x,
              cl)) else -1
            if Mn == cl[0]:
                self.move(-cl[0], 0)
            if Mn == cl[1]:
                self.move(0, -cl[1])
                self.fy = 0
                self.ground = True
            if Mn == cl[2]:
                self.move(cl[2], 0)
            if Mn == cl[3]:
                self.move(0, cl[3])
                self.fy = 0

    def cmd(self, n, t="c", p=0):
        if t == "c":
            if p:
                self.commands[n - 1](self, p)
            else:
                self.commands[n - 1](self)
        else:
            if p:
                self.ret = self.scans[n - 1](self, p)
            else:
                self.ret = self.scans[n - 1](self)


@Existence.logic_class
class deton:
    def __init__(self):
        self.fy = 0
        self.first = True
        self.size = self.width, self.height = self.picture[0].get_size()
        self.obj = Orientation.rect(self.x, self.y, self.width,
          self.height, self.Map.in_map)
        self.scan_rect = Orientation.rect(self.x - 200, self.y, 200,
          self.height, self.Map.in_map)
        self.run = None
        self.ground = True

        self.core = self.props["core"]
        self.laser_gr = self.core.laser_gr
        self.fight = self.core.fight

        self.Mine = None
        self.mine = self.core.mine

        self.pictures = self.picture
        self.picture = self.pictures[0]

        self.dir = 1

        self.lives = self.props["lives"]

        self.centre = Orientation.point(self.x + self.width / 2, self.y +
          self.height / 2, self.Map.in_map)

    def blit(self):
        pygame.draw.rect(self.Map.screen, (40, 255, 40),
          pygame.Rect(self.get_blit()[0] + self.width / 2 - self.lives / 4,
          self.get_blit()[1] - 5, self.lives / 2, 3))
        if self.first:
            self.wll = self.Map.clone_obj("walls", "group")
            self.chars = self.Map.clone_obj("spawns", "group")
            for p, ch in enumerate(self.chars):
                if ch == self:
                    del self.chars[p]
                    break
            self.coll = self.wll + self.chars

            self.commands = [go, mine, detonate]
            self.scans = [lambda self: self.ground + 1, scan, lambda self:
              bool(self.Mine)]
            self.first = False

        self.fy += 0.1
        self.move(0, self.fy)

        if self.run:
            self.run.run()

    def move(self):
        self.obj.x = self.x
        self.obj.y = self.y

        self.scan_rect.x = self.x + (self.width if self.dir == 2 else -200)
        self.scan_rect.y = self.y

        self.centre.x = self.x + self.width / 2
        self.centre.y = self.y + self.height / 2

        self.ground = False

        for obj in self.coll:
            cl = self.obj.collide(obj.obj)
            Mn = min(filter(lambda x: x, cl)) if list(filter(lambda x: x,
              cl)) else -1
            if Mn == cl[0]:
                self.move(-cl[0], 0)
            if Mn == cl[1]:
                self.move(0, -cl[1])
                self.ground = True
                self.fy = 0
            if Mn == cl[2]:
                self.move(cl[2], 0)
            if Mn == cl[3]:
                self.move(0, cl[3])

    def cmd(self, n, t="c", p=0):
        if t == "c":
            if p:
                self.commands[n - 1](self, p)
            else:
                self.commands[n - 1](self)
        else:
            if p:
                self.ret = self.scans[n - 1](self, p)
            else:
                self.ret = self.scans[n - 1](self)


@Existence.logic_class
class flyer:
    def __init__(self):
        self.size = self.width, self.height = self.picture[0].get_size()
        self.obj = Orientation.rect(self.x, self.y, self.width,
          self.height, self.Map.in_map)
        self.scan_rect = Orientation.rect(self.x - 200, self.y, 200,
          self.height, self.Map.in_map)
        self.run = None

        self.obj = Orientation.rect(self.x, self.y, self.width,
          self.height, self.Map.in_map)
        self.centre = Orientation.point(self.x + self.width / 2, self.y +
          self.height / 2, self.Map.in_map)
        self.dr = Orientation.direction(self.centre, 0, self.Map.in_map)
        self.ln = Orientation.line_seg((self.centre, self.dr.get_pos(100)),
          self.Map.in_map)

        self.picture = self.picture[0]

        self.lives = self.props["lives"]

        self.core = self.props["core"]
        self.bomb = self.core.bomb
        self.laser_gr = self.core.laser_gr
        self.time = pygame.time.get_ticks()
        self.fight = self.core.fight

        self.first = True

    def blit(self):
        pygame.draw.rect(self.Map.screen, (40, 255, 40),
          pygame.Rect(self.get_blit()[0] + self.width / 2 - self.lives / 4,
          self.get_blit()[1] - 5, self.lives / 2, 3))
        pygame.draw.line(self.Map.screen, (255, 0, 0),
          self.ln.points[0].get_xy(), self.ln.points[1].get_xy())
        if self.first:
            self.wll = self.Map.clone_obj("walls", "group")
            self.chars = self.Map.clone_obj("spawns", "group")
            for p, ch in enumerate(self.chars):
                if ch == self:
                    del self.chars[p]
                    break
            self.coll = self.wll + self.chars

            self.commands = [turn, move, fire_b]
            self.scans = []

            self.first = False

            self.move(0, 0)

        if self.run:
            self.run.run()

    def move(self):
        self.x = self.centre.x - self.width / 2
        self.y = self.centre.y - self.height / 2

        self.obj.x = self.x
        self.obj.y = self.y

        self.ln.points = (self.dr.point, self.dr.get_pos(100))

        for obj in self.coll:
            cl = self.obj.collide(obj.obj)
            Mn = min(filter(lambda x: x, cl)) if list(filter(lambda x: x,
              cl)) else -1
            if Mn == cl[0]:
                self.centre.x -= cl[0]
                self.move(0, 0)
            if Mn == cl[1]:
                self.centre.y -= cl[1]
                self.move(0, 0)
            if Mn == cl[2]:
                self.centre.x += cl[2]
                self.move(0, 0)
            if Mn == cl[3]:
                self.centre.y += cl[3]
                self.move(0, 0)

    def cmd(self, n, t="c", p=0):
        if t == "c":
            if p:
                self.commands[n - 1](self, p)
            else:
                self.commands[n - 1](self)
        else:
            if p:
                self.ret = self.scans[n - 1](self, p)
            else:
                self.ret = self.scans[n - 1](self)
