import pygame
import Mind

from doc.src import core, editor


class Game:
    def __init__(self):
        self.screen = pygame.display.set_mode((0, 0), pygame.FULLSCREEN)
        pygame.init()

        self.core = core.core(self)

        self.places = [Mind.Imagination.PLACE() for x in range(4)]
        self.Game = Mind.Imagination.Game(self.places[0])

        self.font = pygame.font.SysFont("Arial", 50)
        self.Game.define(type=Mind.Imagination.text_option, font=self.font,
          color=(255, 255, 0), pos_do=Mind.Imagination.ch_color((0, 255,
          0)), anti_pos_do=Mind.Imagination.reset())

        self.keyboard = Mind.Imagination.Keyboard(Mind.Imagination.ARROWS +
          Mind.Imagination.HIT + [(pygame.K_ESCAPE, "quit"), (pygame.K_F1,
          "menu"), (pygame.K_F2, "editor"), (pygame.K_RCTRL, "fire"),
          (pygame.K_F3, "fight"), (pygame.K_F4, "next")])
        self.Game.declare(Mind.Imagination.Vertical_menu, distance=150,
          keyboard=self.keyboard)

        self.Main_menu = self.Game.set_from(places=self.places[0])

        self.Main_menu.set_from(True, text="Start",
          do=Mind.Imagination.joined([Mind.Imagination.link(self.places
          [1]), self.core.start]))
        self.Main_menu.set_from(text="Options")
        self.Main_menu.set_from(text="Quit", do=Mind.Imagination.Quit)
        self.Main_menu.set_options()

        self.editor = editor.editor(self)

    def run(self):
        while self.Game.run():
            if self.keyboard["quit"]:
                self.Game.kill()
            if self.keyboard["editor"]:
                self.Game.change(self.places[3])
            if self.keyboard["fight"]:
                self.core.battle()
                self.Game.change(self.places[1])

            self.screen.fill((255, 255, 255))

            self.Game.blit()

            if self.places[1]:
                self.Map.blit()
                self.keyboard.update()
                if self.keyboard["up"]:
                    self.exp.cmd(2)
                if self.keyboard["left"]:
                    self.exp.cmd(1, p=1)
                if self.keyboard["right"]:
                    self.exp.cmd(1, p=2)
                if self.keyboard["fire"]:
                    self.exp.cmd(3)
                if self.keyboard["next"] == 1:
                    self.core.next()
                self.core.update()

            if self.places[3]:
                self.keyboard.update()
                self.editor.blit()
                if self.keyboard["menu"]:
                    self.Game.change(self.places[0])

            pygame.display.flip()


game = Game()
game.run()

pygame.quit()
